; 10/12/1998
; Edited with PFE and assembled with MPASM 
; 7 characters visible scrolling long text on upper line
; 8 Grey level bars in the middle of the screen
; 5 digits call sign in the bottom
; the 625 lines TV screen looks like this
;
;			  *************
;			  *  T E X T  * this line is scrolling to the left
;			  * grey bars *
;			  *   GB3xx   *
;			  *************
;
; Thanks to Alain FORT and Peter KNIGHT for the original Picdream routines
;
; To customise to your own repeater change the following:
; Enter the fourth and fifth character of your call sign
; (assuming GB3xx) where shown in MDATA. The table is read from the bottom
; up, so the dots and dashes are back to front if read from the top.
; The coding is as follows: 1C = dash, 14 = dot, 04 = gap. Adjust the
; number of lines accordingly then count the lines in MDATA from line 1
; and enter the total plus one where shown in NOTE below.
;
; Replace the fourth and fifth call sign characters in PREPH with yours
; -character after 'Car'(in upper case) as shown.
;
; Modify the scrolling text in DTexte to suit, leave the spaces at the
; beginning and end of the text string.

	TITLE	"SIMPLE TVR CONTROLLER"

	LIST	P=PIC16C84


;NOTE	Alter the decimal number (40) in the next line to the number
;	of lines in the morse look up table, including the first two lines
;	of RETLW 0A, plus one.
;
#Define	ML	D'40'
#Define	W	0
#Define	F	1

	cblock	0x00
		INDF,RTCC,PCL,Status,FSR,PortA,PortB
	endc
	cblock	0x08
		EEData,EEAdr,PClath,IntCon
	endc

	cblock	0x00
		C,DC,Z,PD,TO,RP0,RP1,IRP
	endc

; Page 1 registers
Roption	EQU	01H
TrisA	EQU	05H
TrisB	EQU	06H
RAMbase	EQU	0CH
PCLATH	EQU	0AH

#define	MORSE	PortA,4  ; audio osc control at RA4
#define	MFlag	FLAGS,0  ; morse on flag
#define	KFlag	FLAGS,1  ; 'K' on flag
#define	Sync	PortA,0  ; Synchro out at RA0  (PIN 17)

; DNOP - Double NOP. Delay of 2 cycles, takes only one instruction

DNOP	MACRO
	LOCAL	Label
Label	GOTO	Label+1
	ENDM

; Delay3W - Delay 3 * W cycles, three instructions

Delay3W	MACRO
	LOCAL	Label
	MOVWF	Delay		
Label	DECFSZ	Delay,1
	GOTO	Label
	ENDM

SKIPCC	MACRO
	BTFSC	Status,C
	ENDM

SKIPNZ	MACRO
	BTFSC	Status,Z
	ENDM

	LIST

	CBLOCK	RAMbase
		Delay,Count,Count2,Count3,SubSec	; 5 various registers
		HrT,HrU,MiT,MiU,SeU			; 5 clock registers 
		CA0,CA1,CA2,CA3,CA4,CA5,CA6 		; 6 caracters pointers
		Ta0,Ta1,Ta2,Ta3,Ta4,Ta5,Ta6,TNB,TNB1  	; 7 caracter lines pointers
		Ptrtxt,Mpoint,FLAGS,Period,Temp,Kpoint	; 6 pointers,register,flags
	ENDC

START	ORG	0
	GOTO	Main

INTER	ORG	4
	RETURN

; Table of caracters

Table	ADDWF	PCL,F
Tbase	equ	$
Car0	equ	$-Tbase
CarO	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001110'	; ....***.
Car1	equ	$-Tbase
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001100'	; ....**..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001110'	; ....***.
Car2	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001000'	; ....*...
	RETLW	B'00011111'	; ...*****
Car3	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001' 	;....*...*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000110'	; .....**.
	RETLW	B'00000001'	; .......*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001110'	; ....***.
Car4	equ	$-Tbase
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000110'	; .....**.
	RETLW	B'00001010'	; ....*.*.
	RETLW	B'00010010'	; ...*..*.
	RETLW	B'00011111'	; ...*****
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000010'	; ......*.
Car5	equ	$-Tbase
	RETLW	B'00011111'	; ...*****
	RETLW	B'00010000'	; ...*....
	RETLW	B'00011110'	; ...****.
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001110'	; ....***.
Car6	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00011110'	; ...****.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001110'	; ....***.
Car7	equ	$-Tbase
	RETLW	B'00011111'	; ...*****
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
Car8	equ	$-Tbase
 	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
 	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
 	RETLW	B'00001110'	; ....***.
Car9	equ	$-Tbase
 	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
 	RETLW	B'00001111'	; ....****
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00001110'	; ....***.	
;B0  	D'70'
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00001000'	; ....*...
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000010'	; ......*.
;B3  	D'75'
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000010'	; ......*.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001000'	; ....*...
CarSP	equ	$-Tbase
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
CarA	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011111'	; ...*****
CarH	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011111'	; ...*****
CarU	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001110'	;.....***.
CarD	equ	$-Tbase
	RETLW	B'00011110'	; ...****.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
CarB	equ	$-Tbase
	RETLW	B'00011110'	; ...****.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
CarP	equ	$-Tbase
	RETLW	B'00011110'	; ...****.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011110'	; ...****.
CarL	equ	$-Tbase
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
CarE	equ	$-Tbase
	RETLW	B'00011111'	; ...***** 
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00011100'	; ...***..
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
CarF	equ	$-Tbase
	RETLW	B'00011111'	; ...***** 
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00011100'	; ...***..
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
CarJ	equ	$-Tbase
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00000001'	; .......*
	RETLW	B'00010001'	; ...*...*
CarG	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010011'	; ...*..**
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
CarQ	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00010011'	; ...*..**
CarS	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010000'	; ...*....
	RETLW	B'00001110'	; ....***.
	RETLW	B'00000001'	; .......*
	RETLW	B'00010001'	; ...*...*
CarC	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010000'	; ...*....
	RETLW	B'00010001'	; ...*...*
CarI	equ	$-Tbase
	RETLW	B'00001110'	; ....***.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001110'	; ....***.
CarK	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010010'	; ...*..*.
	RETLW	B'00010100'	; ...*.*..
	RETLW	B'00011000'	; ...**...
	RETLW	B'00010100'	; ...*.*..
	RETLW	B'00010010'	; ...*..*.
CarM	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011011'	; ...**.**
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
CarN	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011001'	; ...**..*
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00010011'	; ...*..**
CarY	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001010'	; ....*.*.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
CarR	equ	$-Tbase
	RETLW	B'00011110'	; ...****.
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00011110'	; ...****.
CarV	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
CarX	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00001010'	; ....*.*.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001010'	; ....*.*.
CarW	equ	$-Tbase
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010001'	; ...*...*
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00010101'	; ...*.*.*
	RETLW	B'00001010'	; ....*.*.
CarZ	equ	$-Tbase
	RETLW	B'00011111'	; ...***** 
	RETLW	B'00000001'	; ...... *
	RETLW	B'00000010'	; ..... *.
	RETLW	B'00000100'	; .... *..
	RETLW	B'00001000'	; ....*...
	RETLW	B'00010000'	; ...*....
CarT	equ	$-Tbase
	RETLW	B'00011111'	; ...*****
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
	RETLW	B'00000100'	; .....*..
Carz	equ	$-Tbase			; lower case z added for frequency
	RETLW	B'00000000'	; ........ 
	RETLW	B'00000000'	; ........
	RETLW	B'00000000'	; ........
	RETLW	B'00011110'	; ...****.
	RETLW	B'00000100'	; .....*..
	RETLW	B'00001000'	; ....*...
	RETLW	B'00011110'	; ...****.

Main
	BSF	Status,RP0	;  adressing bank 1
	MOVLW	B'01110'
	MOVWF	TrisA
	MOVLW	B'11100000'
	MOVWF	TrisB		; ports B as outputs except  RB7 and RB6
	BCF	Roption,7	; we need the integrated pull-up resistors
	BCF	Status,RP0	; adressing bank 0 for the rest of the program
	CLRF	PortA

	CLRF	SeU	;Initialisation clock at 00.00
	CLRF	MiU
	CLRF	MiT
	CLRF	HrU
	CLRF	HrT
	CLRF	Count3
	CLRF	FLAGS
	MOVLW	ML
	MOVWF	Mpoint	;sets morse code length (+1)
	MOVLW	D'6'
	MOVWF	Kpoint	;sets K code length (+1)
	BSF	MFlag	;to give call sign at power up

; Frame starts here.
;
; Frame must be exactly 312.5 Lignes long, each Ligne 64 cycles.
; That ensures frame rate of exactly 50Hz to crystal accuracy.

;5 Long Equalisation pulses

Frame				;Main Loop
	BCF	Sync		; 1		;30us Sync
	DNOP			; 3
	MOVLW	4		; 4
	MOVWF	Count		; 5
Loop1	MOVLW	8		; 6  6
	Delay3W		;30 30
	BSF	Sync		;31 31	;2us Black
	NOP			;32 32
	BCF	Sync		; 1  1	;30us Sync
	NOP			; 2  2
	DECFSZ Count,1   	; -  -
	GOTO	Loop1		; 5
	MOVLW	8		;    5
	Delay3W		;   29
	NOP			;   30
	BSF	Sync		;   31	;2us Black
	NOP			;   32

; Now 5 short equalisation pulses, 4 on interlace

	BCF	Sync		; 1	;2us Sync
	NOP			; 2
	BSF	Sync		; 3	;30us Black
	MOVLW	4		; 4
	BTFSC	SubSec,0	;	; 3 on interlace (SubSec odd)
	MOVLW	3		; 6
	MOVWF	Count		; 7
Loop2	MOVLW	8		; 8  8  8  8
	Delay3W		;32 32 32 32
	BCF	Sync		; 1  1  1  1	;2us Sync
	NOP			; 2  2  2  2
	BSF	Sync		; 3  3  3  3	;30us Black
	NOP			; 4  4  4  4
	DECFSZ Count,1	; -  -  -  -
	GOTO	Loop2		; 7  7  7
	CLRF	TNB		;          7   RAZ de TBN a chaque trame
	MOVLW	8		;          8
	Delay3W		;         32
		
; 304 visible Lines

; *****    First line is morse routine   ******

AUDIO	BCF	Sync		;1	5uS sync
	CALL	Delay4		;5
	BSF	Sync		;6
	BTFSC	MFlag		;7/8	morse flag set?
	GOTO	PERCHK		;9	yes
	BTFSS	KFlag		;9/10	K flag set?
	GOTO	DEL1		;11	no
PERCHK	MOVF	Period,0	;10(K +1) move period to W
	BTFSS	Status,Z	;11/12	Period=0?
	GOTO	DEL2		;13	no
	BTFSS	MFlag		;13/14	morse flag set?
	GOTO	DECKP		;15
	DECF	Mpoint,1	;15	any more?
	MOVF	Mpoint,0	;16
	BTFSS	Status,Z	;17/18	Mpoint=0?
	GOTO	Cdata		;19	no-next morse character
	BCF	MFlag		;19	clear morse flag
	MOVLW	ML		;20	length of morse+1
	MOVWF	Mpoint		;21
	GOTO	CLMORS		;23
DECKP	DECF	Kpoint,1	;17(correct for K) any more K?
	MOVF	Kpoint,0	;18
	BTFSS	Status,Z	;19/20	Kpoint=0?
	GOTO	CdataK		;21	no-next morse character
	BCF	KFlag		;21	clear K flag
	MOVLW	D'6'		;22	length of K+1
	MOVWF	Kpoint		;23
CLMORS	BCF	MORSE		;24
	CLRF	Period		;25	set period=0
	GOTO	DEL3		;27
Cdata	DNOP			;21
CdataK	MOVWF	Temp		;22	Store Mpoint
	MOVLW	HIGH MDATA	;23
	MOVWF	PCLATH		;24
	MOVF	Temp,0		;25
	BTFSC	MFlag		;26/27	morse flag clear?	
	CALL	MDATA		;28
	BTFSS	MFlag		;29/30
	CALL	KDATA		;29/30
	MOVWF	Period		;31	set period
	ANDLW	H'F0'		;32	mask W lower nibble
	BSF	MORSE		;33	start osc.
	SKIPNZ			;34/35	skip next if W not 0
	BCF	MORSE		;35	stop osc.
	MOVLW	H'0F'		;36
	ANDWF	Period,1	;37	mask period upper nibble
	GOTO	DEL4		;39
DEL1	NOP			;12
	MOVLW	D'04'		;13
	Delay3W			;25
	GOTO	DEL3		;27
DEL2	DECF	Period,1	;14
	MOVLW	D'04'		;15
	Delay3W			;27
DEL3	CALL	Delay6		;33
	CALL	Delay6		;39
DEL4	MOVLW	D'07'		;40
	NOP			;41
	Delay3W			;62
	GOTO	BLINES		;64

MDATA	ADDWF	PCL,1		;Morse look up table
	RETURN
	RETLW	0A		; LEAVE THIS LINE -line 1
	RETLW	0A		; LEAVE THIS LINE
	RETLW	14	;		 \
	RETLW	04	 ;		  Enter fifth
	RETLW	1C	  ;G backwards	  character of call
	RETLW	04	 ;		  sign here
	RETLW	1C	;		 /
	RETLW	0C		;space
	RETLW	14	;		 \
	RETLW	04	 ;		  \
	RETLW	14	  ;		  Enter fourth
	RETLW	04	   ;B backwards	  character of call
	RETLW	14	  ;		  sign here
	RETLW	04	 ;		  /
	RETLW	1C	;		 /
	RETLW	0C		;space
	RETLW	1C	;
	RETLW	04	 ;
	RETLW	1C	  ;
	RETLW	04	   ;
	RETLW	14	    ;3 backwards
	RETLW	04	   ;
	RETLW	14	  ;
	RETLW	04	 ;
	RETLW	14	;
	RETLW	0C		;space
	RETLW	14	;
	RETLW	04	 ;
	RETLW	14	  ;
	RETLW	04	   ;B backwards	
	RETLW	14	  ;
	RETLW	04	 ;
	RETLW	1C	;
	RETLW	0C		;space
	RETLW	14	;
	RETLW	04	 ;
	RETLW	1C	  ;G backwards
	RETLW	04	 ;
	RETLW	1C	;

KDATA	ADDWF	PCL,1		;Morse look up table
	RETURN
	RETLW	1C	;
	RETLW	04	 ;
	RETLW	14	  ;K
	RETLW	04	 ;
	RETLW	1C	;

; 40 black Lines 
BLINES	BCF	Sync		; 1
	MOVLW	D'40'		; 2
	CALL	BlkLns	;64

; ****     INIT TEXTE ******   line  42

	BCF 	Sync
	Call 	Preptxt3

; ****    INIT TEXTE CONTINUED ****** line 43

	BCF 	Sync
	Call 	Preptxt4

;********** DISPLAY TEXTE ********* ( + 60 lines) = 103

	BCF	Sync		; 1
	CALL	DisTxt	;64

; 14 black lines = 117

	BCF	Sync		; 1
	MOVLW	D'14'		; 2
	CALL	BlkLns	;64

; *** GREY BARS *** 1 line to set loop + 60 lines + 1 line to exit= 179

	BCF	Sync		; 1
	CALL	Delay4	; 5
	BSF	Sync		; 6
	MOVLW	D'61'		; 7
	MOVWF	TNB		; 8	TNB used as line counter
	MOVLW	D'18'		; 9
	Delay3W			;63
	NOP			;64

BARRE	BCF	Sync		; 1
	CALL	Delay4
	BSF	Sync		; 6    Only odd numbers (for sync=1)
	DECFSZ	TNB,1		; 7
	GOTO	CONT		; 9
	GOTO	ENDGS		;
CONT	MOVLW	B'00000'	;10
	TRIS	PortA		;11
	BSF	PortA,0		;12
	BCF	PortA,1		;13
	BCF	PortA,2		;14
	BCF	PortA,3		;15
	NOP			;16
	DNOP			;18
	MOVLW	D'2'		;19 
	ADDWF	PortA,1		;20   O/P=3
	CALL 	Delay4		;24
	MOVLW	D'2'		;25 
	ADDWF	PortA,1		;26   O/P=5
	CALL	Delay4		;30
	MOVLW	D'2'		;
	ADDWF	PortA,1		;   O/P=7
	CALL 	Delay4		;36
	MOVLW	D'2'		;
	ADDWF	PortA,1		;   O/P=9
	CALL	Delay4		;42
	MOVLW	D'2'		;
	ADDWF	PortA,1		;   O/P=11
	CALL	Delay4		;48
	MOVLW	D'2'		;
	ADDWF	PortA,1		;   O/P=13
	CALL	Delay4		;54
	MOVLW	D'2'		;
	ADDWF	PortA,1		;   O/P=15
	CALL	Delay4		;60
	MOVLW	B'01110'	;61 O/P tristate (except sync & MORSE)
	TRIS	PortA		;62
	GOTO	BARRE		;64

ENDGS	MOVLW	D'18'		;10
	Delay3W			;64

;*****  13  BLACK LINES =192  *****
	BCF	Sync		; 1
	MOVLW	D'13'		; 2
	CALL	BlkLns		;64

;*****  KEYS TEST 1 line = 193 *****
	BCF	Sync		; 1	Line 54
	CALL	TOUCHE		;64

;***** PREPARE CLOCK    =  194 *****
	BCF	Sync		; 1	Line 54
	CALL	PREPH		;64

;***** DISPLAY CLOCK 	= 254  ***** (this takes 60 Lignes)
	BCF	Sync
	CALL	DisTxt

;Increment time
	BCF	Sync		; 1
	INCF	SubSec,1	; 2	Increment 1/50th sec
	MOVLW	-D'50'		; 3
	ADDWF	SubSec,W	; 4	Carry now set if second has expired
	BSF	Sync		; 5
	SKIPCC			; 6	Zero SubSec if =50
	CLRF	SubSec		; 7
	SKIPCC			; 8
	INCF	SeU,1		; 9	And increment Second Units
	SKIPCC			;10
	NOP			;11 	seconds counter modulo 256
	MOVLW	-D'60'		;12
	ADDWF	SeU,W		;13	Carry if needed Second Units->Tens
	SKIPCC			;14
	CLRF	SeU		;15
	SKIPCC			;16
	INCF	MiU,1		;17	Minutes Units
	MOVLW	-D'10'		;18
	ADDWF	MiU,W		;19
	SKIPCC			;20
	BSF     MFlag 		;21  Set(Clear) morse at 10 mins
	SKIPCC			;22
	CLRF	MiU		;23
	SKIPCC			;24
	INCF	MiT,1		;25	Minutes tens
	MOVLW	-D'6'		;26
	ADDWF	MiT,W		;27
	SKIPCC			;28
	CLRF	MiT		;29
	SKIPCC			;30
	INCF	HrU,1		;31
	MOVLW	-D'10'		;32
	ADDWF	HrU,W		;33 
	SKIPCC			;34
	CLRF	HrU		;35
	SKIPCC			;36
	INCF	HrT,1		;37
	MOVF	HrU,W		;38  Now check for Hours=24
	BTFSC	HrT,0		;39
	ADDLW	D'10'		;40  
	BTFSC	HrT,1		;41
	ADDLW	-D'4'		;42
	SKIPCC			;43
	CLRF	HrU		;44 clear hours units
	SKIPCC			;45
	CLRF	HrT		;46 clear hours tens
	MOVLW	D'5'		;47         
	Delay3W			;63
	DNOP			;64

; *****  49 BLACK LINES = 304 *****
	BCF	Sync		; 1		;5us Sync
	MOVLW	D'49'		; 2
	CALL	BlkLns		; 64

; insert half Ligne here on interlace

; Now 5 short equalisation pulses
; prefixed by half video Ligne on interlace

; Slight bodge of CCIR/PAL - the half Ligne segment is actually a short eq pulse
	BCF	Sync		; 1		;2us Sync
	NOP			; 2
	BSF	Sync		; 3		;30us Black
	MOVLW	4		; 4
	BTFSS	SubSec,0	; -
	MOVLW	5		; 6
	MOVWF	Count		; 7
Loop6	MOVLW	8		; 8  8  8  8
	Delay3W			;32 32 32 32
	BCF	Sync		; 1  1  1  1 ; 2us Sync
	NOP			; 2  2  2  2
	BSF	Sync		; 3  3  3   	; 30us Black
	NOP			; 4  4  4  4
	DECFSZ	Count,1		; -  -  -  -
	GOTO	Loop6		; 7  7  7
	MOVLW	7		;          7
	Delay3W			;         28
	DNOP			;         30
	GOTO	Frame		;         32

; Delay routines

Delay6	NOP
Delay5	NOP
Delay4	RETURN

; Some black Lignes
BlkLns	ADDLW	-1
	BSF	Sync		; 1		;59us black
	MOVWF	Count
	DNOP			; 1
Loop5	MOVLW	D'17'		; 1  1  1  1
	MOVWF	Delay		; 1  1  1  1
LoopD9	DECFSZ	Delay,1		;18 18 18 18
	GOTO	LoopD9		;32 32 32 32
	NOP			; 1  1  1  1
	DNOP			; 2  2  2  2
	BCF	Sync		; 1  1  1  1	;5us Sync
	CALL	Delay4		; 4  4  4  4
	BSF	Sync		; 1  1  1  1	;59us Black
	DECFSZ	Count,1		; 1  1  1  2
	GOTO	Loop5		; 2  2  2
	NOP			;          1
	MOVLW	D'17'		;          1
	Delay3W			;         51
	NOP			;          1
	RETURN			;          2

;Display
; Call immediately after BCF Sync, takes 60 Ligne periods

DisTxt	DNOP			; 5	;Ligne 1 noire
	BSF	Sync		; 6
	MOVLW	D'19'		; 7    delai=57
	Delay3W			;64
	BCF	Sync		; 1	lignes 2 et 3 noires
	MOVLW	D'2'		; 2
	CALL	BlkLns		;64
	BCF	Sync		; 1	Ligne 4 au noir , +1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 5
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 6  
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 7  
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 8 
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 9 
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 10 
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 11 
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 12 is black, + 1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 13
	CALL	Showline	;64	
	BCF	Sync		; 1	Ligne 14
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 15
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 16
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 17
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 18
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 19
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 20 is black, +1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 21
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 22
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 23
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 24
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 25
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 26
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 27
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 28 is black,+1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 29
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 30
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 31
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 32
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 33
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 34
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 35
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 36 is black, +1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 37
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 38
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 39
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 40
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 41
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 42
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 43
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 44 is black, +1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 45
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 46
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 47
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 48
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 49
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 50
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 51
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 52 is black, +1 for caracters line
	CALL	INCLIN		;64
	BCF	Sync		; 1	Ligne 53
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 54
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 55
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 56
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 57
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 58
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 59
	CALL	Showline	;64
	BCF	Sync		; 1	Ligne 60
	GOTO	Showline	;64


Showline MOVF	TNB1,W		; 4  old TNB (without plus one)
	ADDWF	CA6,W		; 5  Incline (continued), seventh caracter preparation
	BSF	Sync		; 6
	CALL 	Table		;12
	MOVWF	Ta6		;13
	MOVF	Ta0,W		;15 Carac 1
	MOVWF	PortB		;16  
	RLF	PortB,1		;18
	RLF	PortB,1		;19
	RLF	PortB,1		;20
	RLF	PortB,1		;21
	CLRF	PortB		;22
	MOVF	Ta1,W		;23 Carac 2
	MOVWF	PortB		;24
	RLF	PortB,1		;25
	RLF	PortB,1		;26
	RLF	PortB,1		;27
	RLF	PortB,1		;28
	CLRF	PortB		;29
	MOVF	Ta2,W		;30 Carac 3
	MOVWF	PortB		;31
	RLF	PortB,1		;32
	RLF	PortB,1		;33
	RLF	PortB,1		;34
	RLF	PortB,1		;35
	CLRF	PortB		;36
	MOVF	Ta3,W		;37 Carac 4
	MOVWF	PortB		;38  
	RLF	PortB,1		;39
	RLF	PortB,1		;40
	RLF	PortB,1		;41
	RLF	PortB,1		;42
	CLRF	PortB		;43
	MOVF	Ta4,W		;44 Carac 5
	MOVWF	PortB		;45
	RLF	PortB,1		;46
	RLF	PortB,1		;47
	RLF	PortB,1		;48
	RLF	PortB,1		;49
	CLRF	PortB		;50
	MOVF	Ta5,W		;51 Carac 6
	MOVWF	PortB		;50
	RLF	PortB,1		;51
	RLF	PortB,1		;52
	RLF	PortB,1		;53
	RLF	PortB,1		;54
	CLRF	PortB		;55 Put 0 ( black video between 2 caracters)
	MOVF	Ta6,W		;56 Carac 7
	MOVWF	PortB		;57  
	RLF	PortB,1		;58
	RLF	PortB,1		;59
	RLF	PortB,1		;60
	RLF	PortB,1		;61
	CLRF	PortB		;62 Ouf! no more room for any NOP
	RETURN			;64

Preptxt3  DNOP			; 5	
	BSF	Sync		; 6
	MOVF	SubSec,w	; 7
	ANDLW	B'00000001'	; 8
	SKIPNZ			; 9
	GOTO	GT4		; 10/11	
	MOVLW	D'16'		; 11 -controls scroll speed
	ADDWF	Count3,1	; 12
	SKIPNZ			; 13
	INCF	Ptrtxt,1	; 14
	GOTO 	GT5		; 16
GT4	CALL	Delay5		; 16
GT5 	MOVLW   HIGH Texte	; 17	prepare to read the text page at 3C0
	MOVWF	PClath		; 18 	
	MOVF	Ptrtxt,W	; 19	first caracter
	CALL	Texte		; 25
	MOVWF	CA0		; 26
	INCF	Ptrtxt,1	; 27
	MOVF	Ptrtxt,W	; 28	Second caracter
	CALL	Texte		; 34
	MOVWF	CA1		; 35
	INCF	Ptrtxt,1	; 36
	MOVF	Ptrtxt,W	; 37	Third caracter
	CALL	Texte		; 43
	MOVWF	CA2		; 44
	INCF	Ptrtxt,1	; 45	
	MOVF	Ptrtxt,W	; 46	Fourth caracter
	CALL	Texte		; 52
	MOVWF	CA3		; 53
	INCF	Ptrtxt,1	; 54
	CALL	Delay4		; 58  
	CALL	Delay4		; 62
	RETURN			; 64	

INCLIN	MOVF	TNB,W		; 4  Computing the table input adress 
	MOVWF	TNB1		; 5
	BSF	Sync		; 6  and store in  Ta0 to Ta5 registers
	NOP			; 7 
	MOVF 	TNB,W		; 8	
	ADDWF	CA0,W		; 9   Add TNB to result
	CALL 	Table		; 15  Call line number NB
	MOVWF	Ta0		; 16  Table in TA0
	MOVF 	TNB,W		; 17	
	ADDWF	CA1,W		; 18
	CALL 	Table		; 24
	MOVWF	Ta1		; 25
	MOVF 	TNB,W		; 26	
	ADDWF	CA2,W		; 27
	CALL 	Table		; 33
	MOVWF	Ta2		; 34
	MOVF 	TNB,W		; 35	
	ADDWF	CA3,W		; 36
	CALL 	Table		; 42
	MOVWF	Ta3		; 43
	MOVF 	TNB,W		; 44	
	ADDWF	CA4,W		; 45
	CALL 	Table		; 51
	MOVWF	Ta4		; 52 
	MOVF 	TNB,W		; 53 
	ADDWF	CA5,W		; 54 
	CALL 	Table		; 60 
	MOVWF	Ta5		; 61 
	INCF	TNB,1		; 62  the (Ta6) is in the Showline routine !!
	RETURN			; 64

PREPH	DNOP			; 5	(Clock) Now call sign
	BSF	Sync		; 6
	BCF 	Status,C	; 7

	MOVLW	D'80'		; 8 First caracter is space (black)
	MOVWF	CA0		; 9  

	MOVLW	CarG	; 10  ENTER CALL SIGN 1ST CHARACTER 
	MOVWF	CA1	; 11
	MOVLW	CarB	; 12  ENTER CALL SIGN 2ND CHARACTER
	MOVWF	CA2	; 13
	MOVLW	Car3	; 14  ENTER CALL SIGN 3RD CHARACTER
	MOVWF	CA3	; 15
	MOVLW	CarB	; 16  ENTER CALL SIGN 4TH CHARACTER
	MOVWF	CA4	; 17
	MOVLW	CarG	; 18  ENTER CALL SIGN 5TH CHARACTER
	MOVWF	CA5	; 19
	NOP		; 20

	MOVLW	D'80'		; 21
	MOVWF	CA6		; 22 Last caracter is a space

	MOVLW	D'12'		; 23
	Delay3W			; 59 eq (36)
	
	DNOP			; 61
	CLRF	TNB		; 62
	RETURN			; 64

TOUCHE
	DNOP			;5
	BSF Sync		;6
	MOVF	PortB,w		;7	reading PortB
	XORLW	B'11111111'	;8	compare with before which was '1' due to the pull-up loads
	ANDLW	B'11000000'	;9      mask for RB7 et RB6
	BTFSC	Status,Z	;10	zero set=no buttons
	GOTO	RT1		;12	out if no key press
	BTFSS	PortB,7		;15	test set MFlag input
	BSF	MFlag		;16
	BTFSS	PortB,6		;17	test set KFlag input
	BSF	KFlag		;18
	GOTO	RT2		;20		
RT1	CALL Delay4		;16
	CALL Delay4		;20	
RT2	DNOP			;22
RT3	MOVLW	D'13'		;23
	Delay3W			;62
	return			;64

SCROLL

Texte	ADDWF	PCL,F
DTexte	equ	$
	RETLW	CarSP	; 1  LENGTH = ?? MAXIMUM (characters plus space)
	RETLW	CarSP	; 2
	RETLW	CarSP	; 3
	RETLW	CarSP	; 4
	RETLW	CarSP	; 5  
	RETLW	CarSP	; 6  *** do not modify the first 6 SP characters **
	RETLW	Car3
	RETLW	CarC
	RETLW	CarM
	RETLW	CarS
	RETLW	CarSP
	RETLW	CarA
	RETLW	CarT
	RETLW	CarV
	RETLW	CarSP
	RETLW	CarR
	RETLW	CarE
	RETLW	CarP
	RETLW	CarE
	RETLW	CarA
	RETLW	CarT
	RETLW	CarE
	RETLW	CarR
	RETLW	CarSP
	RETLW	CarQ
	RETLW	CarT
	RETLW	CarH
	RETLW	CarSP
	RETLW	CarS
	RETLW	CarE
	RETLW	CarD
	RETLW	CarG
	RETLW	CarL
	RETLW	CarE
	RETLW	CarY
	RETLW	CarSP
	RETLW	CarN
	RETLW	CarG
	RETLW	CarR
	RETLW	CarSP
	RETLW	CarS
	RETLW	CarO
	RETLW	Car9
	RETLW	Car2
	RETLW	Car3
	RETLW	Car9
	RETLW	Car4
	RETLW	Car2
	RETLW	CarSP
	RETLW	CarI
	RETLW	CarN
	RETLW	CarP
	RETLW	CarU
	RETLW	CarT
	RETLW	CarSP
	RETLW	Car1
	RETLW	Car0
	RETLW	Car4
	RETLW	Car2
	RETLW	Car5
	RETLW	CarM
	RETLW	CarH
	RETLW	Carz
	RETLW	CarSP
	RETLW	CarO
	RETLW	CarU
	RETLW	CarT
	RETLW	CarP
	RETLW	CarU
	RETLW	CarT
	RETLW	CarSP
	RETLW	Car1
	RETLW	Car0
	RETLW	Car2
	RETLW	Car4
	RETLW	Car0
	RETLW	CarM
	RETLW	CarH
	RETLW	Carz
	RETLW	CarSP
	RETLW	CarSP
	RETLW	CarSP
	RETLW	CarSP
	RETLW	CarSP
	RETLW	CarSP	
FTexte	equ	$-6	; necessairy for scrolling 7 caracters on the screen
	RETLW	CarSP

ENDPREP

Preptxt4  DNOP			; 5	
	BSF	Sync		; 6
	MOVF	Ptrtxt,W	; 7	Fith caracter
	CALL	Texte		;13
	MOVWF	CA4		;14
	INCF	Ptrtxt,1	;15	
	MOVF	Ptrtxt,W	;16	Sixth caracter
	CALL	Texte		;22
	MOVWF	CA5		;23 

	INCF	Ptrtxt,1	;24	
	MOVF	Ptrtxt,W	;25	Seventh caracter
	CALL	Texte		;31
	MOVWF	CA6		;32       

	MOVLW	D'7'		; 33  
	Delay3W			; 54   equ 21

	MOVLW	-D'6'		; 55   plus 6 for a one character shift
	ADDWF	Ptrtxt,1	; 56   voila 
	MOVF	Ptrtxt,W	; 57   
	ADDLW	-(FTexte-DTexte); 58 compar to text length
	SKIPCC			; 59
	CLRF	Ptrtxt		; 60 RAZ text pointer if end of scroll
	CLRF 	PClath		; 61 RAZ PClath for reading lire caracters table page at page 0	
	CLRF	TNB		; 62 TNB initialisation
	RETURN			; 64

	END


